<?php

namespace Drupal\fluent\Plugin\FluentFieldItemResolver;

use Drupal\fluent\Plugin\FluentFieldItemResolverPluginBase;
use Drupal\options\Plugin\Field\FieldType\ListItemBase;

/**
 * Plugin implementation of the fluent_field_item_resolver.
 *
 * @FluentFieldItemResolver(
 *   id = "list",
 *   label = @Translation("List field"),
 * )
 */
class ListItem extends FluentFieldItemResolverPluginBase{

  public function can($field): bool {
    return $field instanceof ListItemBase;
  }

  /**
   * @param ListItemBase $field
   *
   * @return mixed|void
   */
  public function handler($field) {
    $possibleOptions = $field->getPossibleOptions();
    $option = $field->get('value')->getValue();

    if (array_key_exists($option, $possibleOptions)) {
      return [$option, $possibleOptions[$option]];
    }

    return NULL;
  }

}
